## proxmox-firewall 0.5.0

=== Makefile ===
include /usr/share/dpkg/default.mk
include defines.mk

PACKAGE=proxmox-firewall
BUILDDIR ?= $(PACKAGE)-$(DEB_VERSION_UPSTREAM)
CARGO ?= cargo

DEB=$(PACKAGE)_$(DEB_VERSION_UPSTREAM_REVISION)_$(DEB_HOST_ARCH).deb
DBG_DEB=$(PACKAGE)-dbgsym_$(DEB_VERSION_UPSTREAM_REVISION)_$(DEB_HOST_ARCH).deb
DSC=$(PACKAGE)_$(DEB_VERSION_UPSTREAM_REVISION).dsc

DEBS = $(DEB) $(DBG_DEB)

ifeq ($(BUILD_MODE), release)
CARGO_BUILD_ARGS += --release
COMPILEDIR := target/release
else
COMPILEDIR := target/debug
endif


all: cargo-build

.PHONY: cargo-build
cargo-build:
	$(CARGO) build $(CARGO_BUILD_ARGS)

.PHONY: build
build: $(BUILDDIR)
$(BUILDDIR):
	rm -rf $@ $@.tmp; mkdir $@.tmp
	cp -a proxmox-firewall proxmox-nftables proxmox-ve-config debian Cargo.toml Makefile defines.mk $@.tmp/
	mv $@.tmp $@

.PHONY: deb
deb: $(DEB)
$(DBG_DEB): $(DEB)
$(DEB): $(BUILDDIR)
	cd $(BUILDDIR); dpkg-buildpackage -b -us -uc
	lintian $(DEB)

.PHONY: test
test:
	$(CARGO) test

.PHONY: dsc
dsc:
	rm -rf $(BUILDDIR) $(DSC)
	$(MAKE) $(DSC)
	lintian $(DSC)
$(DSC): $(BUILDDIR)
	cd $(BUILDDIR); dpkg-buildpackage -S -us -uc -d

sbuild: $(DSC)
	sbuild $<

.PHONY: dinstall
dinstall: $(DEB)
	dpkg -i $(DEB)

.PHONY: distclean
distclean: clean

.PHONY: clean
clean:
	$(CARGO) clean
	rm -f *.deb *.build *.buildinfo *.changes *.dsc $(PACKAGE)*.tar*
	rm -rf $(PACKAGE)-[0-9]*/
	find . -name '*~' -exec rm {} ';'

.PHONY: upload
upload: UPLOAD_DIST ?= $(DEB_DISTRIBUTION)
upload: $(DEB) $(DBG_DEB)
	tar cf - $(DEB) $(DBG_DEB) | ssh -X repoman@repo.proxmox.com -- upload --product pve --dist $(UPLOAD_DIST)

=== debian/changelog ===
proxmox-firewall (0.5.0) bookworm; urgency=medium

  * rules: allow vital ICMP(v6) types irregardless of any other rules, which
    is particularly for ICMPv6 related ones. This follows RFC 4890.

  * service: flush firewall rules on force disable to avoid a race condition
    where the nftables rule-set never gets flushed and persists after
    disabling.

  * update to newer proxmox-sys and proxmox-schema dependencies

  * conntrack: arp: move handling to guest chains in order to avoid affecting
    bridged host interfaces.

  * guest: match arp packets via 'meta' filter type to ensure that valid ARP
    packets encapsulated in VLAN frames get through, as with the 'ether' type
    ARP traffic inside VLANs always gets dropped.

 -- Proxmox Support Team <support@proxmox.com>  Mon, 22 Jul 2024 18:05:36 +0200

proxmox-firewall (0.4.2) bookworm; urgency=medium

  * rules: use proper ICMPv6 admin-prohibited type for rejecting IPv6 traffic,
    host-prohibited only exist for IPv4

  * guest out: fix handling ARP traffic with a default block/reject policy

  * guest out: fix handling connection tracking with a default block/reject
    policy

 -- Proxmox Support Team <support@proxmox.com>  Tue, 21 May 2024 15:43:51 +0200

proxmox-firewall (0.4.1) bookworm; urgency=medium

  * check for file flag in /run signaling that this service is disabled and
    skip config parsing completely in that case to avoid logging errors even
    if the user cannot be affected by them

 -- Proxmox Support Team <support@proxmox.com>  Fri, 26 Apr 2024 17:22:01 +0200

proxmox-firewall (0.4.0) bookworm; urgency=medium

  * config: macros: add SPICE-proxy macro

  * config: nftables: add support for icmp-type any

  * firewall: improve error handling of daemon

 -- Proxmox Support Team <support@proxmox.com>  Thu, 25 Apr 2024 19:29:47 +0200

proxmox-firewall (0.3.1) bookworm; urgency=medium

  * fix #5410: config: fix naming scheme for aliases in firewall config, allow
    underscores as long as it's not the first character.

 -- Proxmox Support Team <support@proxmox.com>  Wed, 24 Apr 2024 19:40:16 +0200

proxmox-firewall (0.3.0) bookworm; urgency=medium

  * firewall: improve handling REJECT rules

 -- Proxmox Support Team <support@proxmox.com>  Tue, 23 Apr 2024 18:33:38 +0200

proxmox-firewall (0.2.1) bookworm; urgency=medium

  * firewall: properly cleanup tables when firewall is inactive

 -- Proxmox Support Team <support@proxmox.com>  Tue, 23 Apr 2024 13:20:12 +0200

proxmox-firewall (0.2.0) bookworm; urgency=medium

  * firewall: wait for nft process to avoid left-over zombie processes

  * firewall: change systemd unit file to type simple and drop PID file, not
    relevant here

 -- Proxmox Support Team <support@proxmox.com>  Fri, 19 Apr 2024 19:42:26 +0200

proxmox-firewall (0.1.0) bookworm; urgency=medium

  * Initial release.

 -- Proxmox Support Team <support@proxmox.com>  Thu, 18 Apr 2024 21:07:32 +0200

=== debian/control ===
Source: proxmox-firewall
Section: admin
Priority: optional
Maintainer: Proxmox Support Team <support@proxmox.com>
Build-Depends: cargo:native,
               debhelper-compat (= 13),
               librust-anyhow-1+default-dev,
               librust-env-logger-0.10+default-dev,
               librust-insta-dev,
               librust-libc-0.2+default-dev,
               librust-log-0.4+default-dev (>= 0.4.17-~~),
               librust-nix-0.26+default-dev (>= 0.26.1-~~),
               librust-proxmox-schema-3+default-dev (>= 3.1.2-~~),
               librust-proxmox-sortable-macro-dev,
               librust-proxmox-sys-dev (>= 0.6~),
               librust-serde-1+default-dev,
               librust-serde-1+derive-dev,
               librust-serde-json-1+default-dev,
               librust-serde-plain-1+default-dev,
               librust-serde-with+default-dev,
               librust-signal-hook-dev,
               librust-thiserror-dev,
               libstd-rust-dev,
               netbase,
               python3,
               rustc:native,
Standards-Version: 4.6.2
Homepage: https://www.proxmox.com

Package: proxmox-firewall
Architecture: any
Conflicts: ulogd,
Depends: netbase, nftables, pve-firewall, ${misc:Depends}, ${shlibs:Depends},
Description: Proxmox's nftables-based firewall written in rust
 This package contains a nftables-based implementation of the Proxmox VE
 Firewall

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk
include /usr/share/rustc/architecture.mk

export BUILD_MODE=release

export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
export DEB_HOST_RUST_TYPE DEB_HOST_GNU_TYPE

export CARGO=/usr/share/cargo/bin/cargo
export CARGO_HOME = $(CURDIR)/debian/cargo_home

export DEB_CARGO_CRATE=proxmox-firewall_$(DEB_VERSION_UPSTREAM)
export DEB_CARGO_PACKAGE=proxmox-firewall

%:
	dh $@

override_dh_auto_configure:
	@perl -ne 'if (/^version\s*=\s*"(\d+(?:\.\d+)+)"/) { my $$v_cargo = $$1; my $$v_deb = "$(DEB_VERSION_UPSTREAM)"; \
	    die "ERROR: d/changelog <-> Cargo.toml version mismatch: $$v_cargo != $$v_deb\n" if $$v_cargo ne $$v_deb; exit(0); }' proxmox-firewall/Cargo.toml
	$(CARGO) prepare-debian $(CURDIR)/debian/cargo_registry --link-from-system
	dh_auto_configure

override_dh_installsystemd:
	dh_installsystemd proxmox-firewall.service
